#include <sgjbase.h>
#include <sgjmig.h>
int main(int argc, char **argv)
{
  filehead shot,receiver,shotreceiver;
  __complex__ float **ds,**dr,**dsr;
  float min_s,max_s,d_s,min_h,max_h,d_h;
  float sx,h;
  int blocksize,ishot,is,iw,ih,ihsr;

  initpar(argc,argv);

  file_open_input("Shot",&shot);
  file_open_input("Receiver",&receiver);
  
  min_s=MIN(shot.o[2],receiver.o[2]); 
  max_s=MAX(shot.o[2]+(shot.n[2]-1)*shot.d[2],receiver.o[2]+(receiver.n[2]-1)*receiver.d[2]);
  d_s=MIN(shot.d[2],receiver.d[2]);
 
  min_h=MIN(shot.o[1],receiver.o[1]);
  max_h=MAX(shot.o[1]+(shot.n[1]-1)*shot.d[1],receiver.o[1]+(receiver.n[1]-1)*receiver.d[1]);  
  d_h=MIN(shot.d[1],receiver.d[1]);

  shotreceiver.ndims=3;
  shotreceiver.o[0]=shot.o[0]; shotreceiver.d[0]=shot.d[0]; shotreceiver.n[0]=shot.n[0];
  shotreceiver.o[1]=min_h;     shotreceiver.d[1]=d_h;       shotreceiver.n[1]=(max_h-min_h)/d_h+1;
  shotreceiver.o[2]=min_s;     shotreceiver.d[2]=d_s;       shotreceiver.n[2]=(max_s-min_s)/d_s+1;

  file_open_output_c("Out",shotreceiver);

  ds=allocate_c2(shot.n[1],shot.n[0]);
  dr=allocate_c2(receiver.n[1],receiver.n[0]);
  dsr=allocate_c2(shotreceiver.n[1],shotreceiver.n[0]); 

  for (is=0;is<shotreceiver.n[2];is++){
    sx=is*d_s+min_s;
    if (sx >=shot.o[2] && sx<=shot.o[2]+shot.d[2]*(shot.n[2]-1) ){
      blocksize=8*shot.n[0]*shot.n[1];
      ishot=(sx-shot.o[2])/shot.d[2];
      if ( sseek_block("Shot",ishot,blocksize,0)!=ishot) seperr("Shot seek err\n");
      if (sreed("Shot",*ds,blocksize)!=blocksize) seperr("Shot read err\n");
      for(ih=0;ih<shot.n[1];ih++){
        h=ih*shot.d[1]+shot.o[1];
        ihsr=(h-shotreceiver.o[1])/shotreceiver.d[1];
        for(iw=0;iw<shot.n[0];iw++){
          dsr[ihsr][iw]+=ds[ih][iw];
        }
      }
    }
    if (sx >=receiver.o[2] && sx<=receiver.o[2]+receiver.d[2]*(receiver.n[2]-1) ){
      blocksize=8*receiver.n[0]*receiver.n[1];
      ishot=(sx-receiver.o[2])/receiver.d[2];
      if ( sseek_block("Receiver",ishot,blocksize,0)!=ishot) seperr("Shot seek err\n");
      if (sreed("Receiver",*dr,blocksize)!=blocksize) seperr("Shot read err\n");
      for(ih=0;ih<receiver.n[1];ih++){
        h=ih*receiver.d[1]+receiver.o[1];
        ihsr=(h-shotreceiver.o[1])/shotreceiver.d[1];
        for(iw=0;iw<receiver.n[0];iw++){
          dsr[ihsr][iw]+=dr[ih][iw];
        }
      }
    }
    if (srite("Out",*dsr,shotreceiver.n[1]*shotreceiver.n[0]*8)!=shotreceiver.n[1]*shotreceiver.n[0]*8) seperr("err write\n");
  } 
  free_c2(ds); free_c2(dr); free_c2(dsr);

  return 0;
}
